package Client;

import java.awt.*;
import java.awt.event.*;
import ImageClient;

/**<dl><dt>
 * Module ID: ImageCanvas.java                 <dt>
 * Note     : Ce module necessite le JDK 1.1.1 <dt>
 * Date     : 18 Avril 1997
 * </dl>
 * @author    Olivier Langlois
 * @version   1.000
 */
public class ImageCanvas extends Canvas implements MouseListener
{
  private Image       im;
  private ImageClient client;

  // Constructeurs
  /**
   * Construit un nouvel objet ImageClient
   * @param client reference de l'applet parent de ce canvas.
   */
  public ImageCanvas( ImageClient client )
  {
    this.client = client;
  }

  /**
   * Methode enveloppe pour ajuster la variable privee im.
   * @param im reference a sauvegarder.
   */
  public void setImage(Image im)
  {
    this.im = im;
  }

  public void update(Graphics g)
  {
    if (im != null) g.drawImage(im, 0, 0, this);
  }

  public void paint(Graphics g)
  {
    update(g);
  }

  public void mouseClicked( MouseEvent me )
  {
    int x = me.getX();
    int y = me.getY();
    int width;

    if( x < (width = im.getWidth(this)) && y < im.getHeight(this) )
    {
      client.drawMatrix( (y/64)*(width/64) + x/64 );
    }
  }

  public void mouseEntered( MouseEvent me )
  {
    setCursor( Cursor.getPredefinedCursor(Cursor.HAND_CURSOR) );
  }

  public void mouseExited( MouseEvent me )
  {
  }

  public void mousePressed( MouseEvent me )
  {
  }

  public void mouseReleased( MouseEvent me )
  {
  }
}
